<!DOCTYPE html>
<html lang="de">
  <head>
    <meta http-equiv="Content-Type" content="text/html;
      charset=utf-8">
    <meta name="author" content="Guenter Quast" >
    <meta name="Description" content="Jupyter Notebooks
	  zur Datenauswertung für Praktika in der Physik" lang="de">
    <meta name="created" content="2020-14-03">
    <meta name="updated" content="2021-12-04">
    <meta name="Language" content="german">
    <meta name="keywords" content="Datenauswertung, Datenanalyse, physikalisches Praktikum,
          jupyter notebook, Fehlerrechnung">
    <meta name="robots" content="index, follow">
    <title>Jupyter Tutorial zur Fehlerrechnung</title>
    
<!-- auto-refresh page 
    <meta http-equiv="refresh" content="60">  
    --> 
<!-- Silbentrennung -->

    <style>  
      h1 {color: #0080A0; font-size: 20px;
      }
      h2 {color: #0080A0; font-size: 16px;
      }
      p {
         margin-left: 10px;
         margin-right: 10px;
         -moz-hyphens: auto;
         -o-hyphens: auto;
         -webkit-hyphens: auto;
         -ms-hyphens: auto;
        hyphens: auto;
        max-width: 50em; 
      <!--   text-align: justify; -->
      }
      div {
      }     
      body {
          font-family: Helvetica, sans-serif;
          font: normal 14px Verdana, Arial;      
          margin-left: 30px
          color:#000000;
          background-color:Snow;
      }     
    </style>
  </head>

<body>

<br>
<font font="" style="color: rgb(51, 51, 101)";>
<big> <b><em>jupyter</em> Tutorials zur Datenauswertung </b> </big> </font>
<br><br>
<big> <font size=+1>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
   <b>&bdquo;<u>(Moderne) Fehlerrechnung in physikalischen Praktika</u>&ldquo; </b> 
</big> </font>
<hr style="width: 100%; height: 2px;">
<!-------------------------------------------------------------------------------------------->
<div style="text-align:right"> Günter Quast, März 2020, Apr.'21 &nbsp; </div>

<article>
<h1>Einführung in die Verwendung von  <em>jupyter notebooks</em> </h1> 

<p>
Das quelloffene Projekt <a href="https://jupyter.org/install"> <em>jupyter</em> </a>
bietet eine web-basierte interaktive Umgebung für wissenschaftliche Berech&shy;nungen
und Datenauswertung. Die zu Grunde liegenden Dateien sind sogenannte &bdquo;Notebooks&ldquo;, 
die sowohl formatierten Text als auch Programmcode u.&thinsp;a. in der Sprache <em>Python</em> 
und die entsprechende Programmausgabe in Form von Text und Grafiken in einem einzigen
Dokument vom Typ <em>.ipynb</em> speichern.<br> 
<br>
Vorhandene <em>Python</em>-Skripte sind direkt oder mit sehr wenig Aufwand unter
<em>jupyter</em> lauffähig. Die <em>jupyter</em>-Oberfläche ersetzt eine
Entwicklungsumgebung wie z.B. <em>IDLE</em>.
Zur Formatierung eingegebener Texte wird eine leicht zu erlernende Markup-Sprache 
verwendet, die auch Ausdrücke in LaTeX korrekt verarbeitet. Die Konversion vorhandener
Textbausteine ist also leicht zu bewerkstelligen. Notebooks können in verschiedenen
Formaten als komplette Dokumente, insb. auch <em>.pdf</em> und <em>.html</em>, 
exportiert und ggf. ausgedruckt werden. <br>
<br>
Zur <b>Anzeige und Bearbeitung</b> dient ein beliebiger Web-Browser, der sich mit einem
<em>jupyter</em>-Server verbindet. <br>
<br>
Ein <em>jupyter</em>-Server kann entweder lokal auf dem gleichen System wie der Browser
laufen oder auch auf einem über das Netzwerk angebundenen Rechner. 
Bei Verwendung eines Servers im Netzwerk oder auch in einer Compute-Cloud muss das Gerät
des Endnutzers nicht besonders leistungsfähig sein, sondern lediglich einen der gängigen
Web-Browser unterstützten. <br>

<p>
Eine <b>lokale Installation</b> auf dem System des Nutzers ist leicht möglich, wenn
eine <em>Python</em>-Installation vorhanden ist. Dazu  den <em>jupyter</em>-Server
mit dem installationswerkzeug <em>pip</em> installieren:
<pre><code>      > pip install jupyterlab </code></pre>
</p>
<p>
Dies funktioniert problemlos unter Linux, Mac&nbsp;OS oder auf Windows-Systemen
mit installierter <em>Python</em>-Umgebung.
<ul>
  <li> unter <b> Linux </b> ist <em>Python</em> immer dabei,
	häufig allerdings noch in der älteren Version 2.x. <br>
	Mit Hilfe des Paket-Managers sollte eine Version 3.5
        oder höher installiert werden;
  </li>
  <li> für <b> Windows&nbsp;10 </b> wird die Umgebung 
  <a href="https://sourceforge.net/projects/winpython"> WinPython</a> empfohlen, die 
  auch ohne Installation <br>
  z.B. von einem externen Speicher läuft. WinPython bringt 
  einen eigenen <em>jupyter</em>-Server mit;  
  </li>
  <li> für <b> MacOS</b> wird 
  <a href="https://docs.anaconda.com/anaconda/install/mac-os/"> 
           Anaconda </a> empfohlen. 
  </li>
</ul> 
</p>

<p>
Auf dem eigenen System kann nun mittels Eingabe von
<pre><code>      > jupyter-lab </code></pre>
<p>
auf der Kommandozeile der Server gestartet werden. Normalerweise startet
dann ein Web-Browser, und es erscheint die <em>jupyter</em>-Oberfläche. 
Sollte dies nicht der Fall sein, wird eine URL angezeigt, die Sie in 
Ihren Web-Browser eingeben können, nachdem Sie ihn selbst gestartet haben. <br> 
<br>
Wenn Sie einen Server im Netzwerk verwenden, geben Sie die URL des Servers
in die Adresszeile des Browsers ein. In der Regel müssen Sie sich mit 
Benutzernamen und Kennwort anmelden. Danach startet auch in diesem Fall
die <em>jupyter</em>-Oberfläche. <br>
</p>
<p>
Die Fakultät für Physik am KIT betreibt einen <em>jupyter</em>-Server unter
der URL 
<div>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <a href="https://jupytermachine.etp.kit.edu"> https://jupytermachine.etp.kit.edu</a>.
</div>
Dieser Dienst kann für Angehörige der Physik am KIT über die Authentifizierung
im CIP-Pool genutzt werden. 
</p>
<p>
Eine allgemein offene Möglichkeit zum Ausprobieren der Jupyter-Tutorials
bietet der freie und kostenlose Dienst <em>mybinder.org<em>, der einen in
einen  Docker-Container eingebetteten <em>jupyter</em>-Server mit allen in
diesem Dokument beschriebenen Tutorials zur Verfügung stellt - allerdings mit 
bescheidenen Rechenressourcen. Hier der Link zu diesem sehr empfehlenswerten
Web-Dienst:      
<div>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <a href="https://mybinder.org/v2/git/https%3A%2F%2Fgit.scc.kit.edu%2Fyh5078%2Fdatenanalyse/master">
  <em>jupyter server auf mybinder.org</em></a>.
</div>
</p>

<h2> Beispiele zum Kennenlernen und Tutorials</h2>

<p>Einige einfache Beispiele und Tutorials stehen zum Download bereit.
Am besten speichern Sie sie lokal auf ihrem Computer in einem eigenen
  Arbeitsverezeichnis; nutzen Sie dazu die Funktion
  <em> "Ziel speichern unter..."</em> ihres Browsers
  (i.A. durch Rechts-Klick auf den Link zur Datei). <br>
<br>

Einige jupyter-Notebooks zur Einführung in <em>juypter</em>,
<em>Python</em> und Anwendungen zur Datenauswertung  sind hier
zusammengestellt:<br>
<ol>
  <li> Spickzettel für <em> jupyter </em>:
    <a href="JupyterCheatsheet.ipynb"> JupyterCheatsheet.ipynb </a> 
    </li>
  <li> Einführung in <em> Python </em>:
    <a href="PythonIntro.ipynb"> PythonIntro.ipynb </a> 
    </li>
  <li> Spickzettel für <em> Python </em>:
    <a href="PythonCheatsheet.ipynb"> PythonCheatsheet.ipynb </a> 
    </li>
  <li> Grundlagen zur Verwendung von <em>matplotlib</em> :
    <a href="matplotlibTutorial.ipynb"> matplotlibTutorial.ipynb </a> 
    </li>
  <li> Grundlagen der Statistik: 
  <a href="IntroStatistik.ipynb"> IntroStatistik.ipynb </a>
  </li>
  <li> Fehlerrechnung im Physikalischen Praktikum: 
    <a href="Fehlerrechnung.ipynb"> Fehlerrechnung.ipynb </a> 
  </li>
  <li> Tutorium zu kafe2: 
    <a href="kafe2Tutorial.ipynb"> kafe2Tutorial.ipynb </a> 
  </li>
  <li> Anpassung mit der Maximum-Likelihood-Methode: 
    <a href="negLogLFits.ipynb"> negLogLFits.ipynb </a> 
  </li>
  <li> Modellanpassung für Fortgeschrittene (engl.): 
    <a href="advancedFitting.ipynb"> advancedFitting.ipynb </a> 
  <li> Einführung in das Datenverwaltungs- und -analyse-Werkzeug
    <em>pandas</em> (engl.):
    <a href="pandasBasics.ipynb"> pandasBasics.ipynb </a> 
  </li>
</ol>

</p>


<h2> Los geht's !</h2>
<p>
  Starten Sie einen eigenen <em>jupyter</em>-Server,
  oder verbinden Sie sich über Ihren Web-Browser mit dem
  <a href="https://jupytermachine.etp.kit.edu">
  Jupyter-Server der Fakultät für Physik </a>
  oder mit dem freien Dienst
  <a href="https://mybinder.org/v2/git/https%3A%2F%2Fgit.scc.kit.edu%2Fyh5078%2Fdatenanalyse/master">
  <em>mybinder.org</em></a>. 
  
  Wenn die <em>jupyter</em>-Oberfläche in Ihrem Web-Browser erscheint, kann
  es direkt los gehen. Sie sehen eine Menüleiste, darunter links ein Fenster
  mit einer Dateiliste des Arbeitsverzeichnisses, und rechts ein großes 
  Fenster für die Anzeige von Text, Programm-Code und Programmausgaben.<br>
  <br>
  Links oben in der Menüleiste gibt es ein Symbol "&#8613; (Upload)" für das
  (Hoch-)Laden eines <em>jupyter</em>-Notebooks in den Arbeitsbereich des
  <em>jupyter</em>-Servers.

  Klicken Sie es an und wählen Sie im Datei-Browser eine der eben
  heruntergeladnen Dateien des Typs <em>.ipynb</em> aus.

  Das ausgewählte Notebook erscheint nun in der Dateiliste; starten Sie
  es mit einem Doppelklick.
</p>

<p>
Sie sehen nun den Inhalt des ausgewählten Notebooks im Hauptfenster
der Oberfläche. Folgen Sie den Hinweisen im angezeigten Text; die
Tutorials sind so ausgelegt, dass sie selbsterklärend sein sollten. 
</p>

<p> Um einen Eindruck zu gewinnen, ohne <em>jupyter</em> auszuführen,
  können Sie die folgenden Ausdrucke im pdf-Format anschauen:

<ul>
  <li> Einführung in <em>matplotlib</em>: 
  <a href="matplotlibTutorial.pdf"> matplotlibTutorial.pdf </a>
  </li>
  <li> Grundlagen der Statistik: 
  <a href="IntroStatistik.pdf"> IntroStatistik.pdf </a>
  </li>
  <li> Fehlerrechnung im Physikalischen Praktikum: 
    <a href="Fehlerrechnung.pdf"> Fehlerrechnung.pdf </a>
  </li>
  <li> Anpassungen mit der Maximum-Likelihood-Methode: 
    <a href="negLogLFits.pdf"> negLogLFits.pdf </a>
  </li>
  <li> für Fortgeschrittene (engl.): 
    <a href="advancedFitting.pdf"> advancedFitting.pdf </a>
  </li>
  <br>    
  <li style="font-weight: normal;">
    <a href="."> alle Tutorials zum Download</a>
  </li>
</ul>
<b> <u>Weitere Links:</u> </b> 
<ul>
 <li style="font-weight: normal;">
    <a href="http://www.etp.kit.edu/~quast/Skripte/Chi2Method.pdf">
  Skript: Funktionsanpassung mit der &chi;<sup>2</sup>-Methode </a>
 </li>
 <li style="font-weight: normal;"> 
      Funktionsanpassung in Python (Paket <em>kafe</em> bzw. <em>kafe2</em>)</a> 
    &nbsp; &nbsp;
    <ul>
      <li> 
      <a href="http://www.etp.kit.edu/~quast/kafe2/htmldoc"> Dokumentation </a> 
      &nbsp; &nbsp; 
      <a href="http://www.etp.kit.edu/~quast/kafe2/"> Download <em>kafe2</em> </a> 
      &nbsp; &nbsp; 
      <a href="https://github.com/dsavoiu/kafe2"> <em>kafe2</em> auf github</a>
      </li>
      <li>  alte Version      &nbsp; &nbsp;   
      <a href="http://www.etp.kit.edu/~quast/kafe/htmldoc"> Dokumentation </a> 
      &nbsp; &nbsp; 
      <a href="http://www.etp.kit.edu/~quast/kafe/"> Download <em> kafe <em> </a> 
      &nbsp; &nbsp; 
      <a href="https://github.com/dsavoiu/kafe"> <em>kafe</em> Vers. 1 auf github</a> 
    </li> </ul>
   <li>
    Software-Tools im Paket
          <a href="http://www.etp.kit.edu/~quast/PhyPraKit/htmldoc" target=_blank> PhyPraKit</a>,
     &nbsp; Download des gesamten Pakets mit Beispielen
      <a href="http://www.etp.kit.edu/~quast/PhyPraKit/PhyPraKit-master.zip"> PhyPraKit-master.zip   </a>
     <br>
      <a href="https://git.scc.kit.edu/yh5078/PhyPraKit"> <em>PhyPraKit</em> auf git.scc</a>
       &nbsp;&nbsp; und <a href="http://www.etp.kit.edu/~quast/PhyPraKit/">
      Dateien zum Download</a>
    </li>    
  </ul>
</div> 

</article>
</body> </html>
